﻿// MessageBox.cpp : 구현 파일입니다.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "MessageBox.h"


// CMessageBox 대화 상자입니다.

IMPLEMENT_DYNAMIC(CMessageBox, CDialog)

CMessageBox::CMessageBox(CWnd* pParent /*=NULL*/)
	: CDialog(CMessageBox::IDD, pParent)
	, m_strCaption(_T(""))
	, m_strText(_T(""))
	, m_nFlag(0)
	, m_nType(0)
{
}

CMessageBox::~CMessageBox()
{
}

void CMessageBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CLOSE_BUTTON, m_btnClose);
}

BEGIN_MESSAGE_MAP(CMessageBox, CDialog)
	ON_WM_NCHITTEST()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, &CMessageBox::OnBnClickedCloseButton)
END_MESSAGE_MAP()

// CMessageBox 메시지 처리기입니다.
/*
 * nFlag : MessageBox 형태
 * nType : MB_OKCANCEL, MB_OK... 버튼 타입( MB_YESNO...이것도? )
 */
void CMessageBox::Init(LPCTSTR pszText, LPCTSTR pszCaption, int nFlag, int nType)
{
	ASSERT(AfxIsValidString(pszText));
	ASSERT(AfxIsValidString(pszCaption));

	m_strCaption = pszCaption;
	m_strText = pszText;
	m_nFlag = nFlag;
	m_nType = nType;
}

LRESULT CMessageBox::OnNcHitTest(CPoint point)
{
	return HTCAPTION;
}

BOOL CMessageBox::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_gwMainBody.SetDrawImage(_T("IMAGES\\12_center.bmp"));
	m_btnClose.SetBtnBitmapFile(_T("IMAGES\\controlskin\\closing.bmp"),RGB(0,0,0));
	HGDIOBJ hFont = NULL;
	LOGFONT stLogFont;
	CDC* pDC = NULL;
	CSize sizeCaption, sizeText, sizeLine/*, sizeDialog*/;
	int nSub;
	CString strLineText;
	int nLeft, nTop, nRight, nBottom;
	CFont* pOldFont;

	hFont = ::GetStockObject(DEFAULT_GUI_FONT);
	GetObject( hFont, sizeof(LOGFONT), &stLogFont);	
	m_font.CreateFontIndirect(&stLogFont);
	this->SetFont(&m_font, FALSE);

	//메세지 박스 크기 계산
	pDC = GetDC();
	pOldFont = pDC->SelectObject(&m_font);
	sizeCaption = pDC->GetOutputTextExtent(m_strCaption);
	sizeText.cx = 0;
	sizeText.cy = 0;
	nSub = 0;
	while(AfxExtractSubString(strLineText, m_strText, nSub++))
	{
		sizeLine = pDC->GetOutputTextExtent(strLineText);
		sizeText.cx = max(sizeText.cx, sizeLine.cx);
		sizeText.cy += (sizeLine.cy + 5);
	}

	m_sizeDialog.cx = max(sizeCaption.cx, sizeText.cx);
	m_sizeDialog.cy = sizeText.cy;
	m_sizeDialog.cx += 60;
	m_sizeDialog.cx = max(m_sizeDialog.cx, 320);
	m_sizeDialog.cy = max(m_sizeDialog.cy, 120);
	this->SetWindowPos(NULL, 0, 0, m_sizeDialog.cx, m_sizeDialog.cy, SWP_NOMOVE);
	//m_btnClose.MoveWindow(m_sizeDialog.cx - 20, 10, 13, 13, TRUE);
	m_btnClose.MoveWindow(m_sizeDialog.cx - 20, 10, 8, 7, TRUE);
	if(m_nType == MB_OKCANCEL || m_nType == MB_YESNO)
	{
		//cancel버튼
		nLeft = m_sizeDialog.cx / 2 + 5;
		nRight = nLeft + 50;
		nBottom = m_sizeDialog.cy - 10;
		nTop = nBottom - 20;

		m_btnCancel.Create(m_nType == MB_OKCANCEL?_T("취소"):_T("아니오"), 
							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(nLeft, nTop, nRight, nBottom), 
							this, IDCANCEL);
	}
	//Ok버튼
	if(m_nType == MB_OKCANCEL || m_nType == MB_YESNO)
		nLeft = m_sizeDialog.cx / 2 - 50;
	else
		nLeft = m_sizeDialog.cx / 2 - 25;
	nRight = nLeft + 50;
	nBottom = m_sizeDialog.cy - 10;
	nTop = nBottom - 20;
	m_btnOk.Create(m_nType == MB_YESNO?_T("예"):_T("확인"), 
					WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(nLeft, nTop, nRight, nBottom), 
					this, IDOK);
	pDC->SelectObject(pOldFont);
	ReleaseDC(pDC);
	return TRUE; 
}

void CMessageBox::OnDestroy()
{
	CDialog::OnDestroy();
}

BOOL CMessageBox::OnEraseBkgnd(CDC* pDC)
{
	return CDialog::OnEraseBkgnd(pDC);
}

void CMessageBox::OnPaint()
{
	CPaintDC dc(this);
	m_gwMainBody.DrawingImage(&dc, 0, 0, m_sizeDialog.cx, m_sizeDialog.cy);
	CRect rectClient, rectCaption, rectText;
	CFont* pOldFont;
	GetClientRect(&rectClient);
	pOldFont = dc.SelectObject(&m_font);
	rectCaption.SetRect(10, 3, rectClient.Width() - 20, 28);
	rectText.SetRect(10, 40, rectClient.Width() - 20, rectClient.Height() - 40);
	dc.DrawText(m_strText, rectText, DT_CENTER);

	dc.SelectObject(pOldFont);
}

void CMessageBox::OnBnClickedCloseButton()
{
	OnOK();
}
